function [ D_ ] = DCalculation( d , l , tstar , Model )
%DCalculation Construct the demand shock to the discount factor

GridPoints = Model.Numerics.T;
tg = (cumsum(ones(GridPoints,1))-1);

D_ = -d.*sin((1+0.5.*tg./l).*pi()).*(tg<=l) + ...
     (d - 0.5.*d.*( sin((1.5+(tg-l)./(tstar-l)).*pi()) + 1 ) ).*(tg>l).*(tg<=tstar);

D_ = [0 ; D_ ; 0 ]; 
 
end

