function [ L_ , ZStar ] = AggregatesCalculation( G_tminus1_wp , w_t_Zp , Z_t_wp , Pi_t , a_t , L , Model )
%AggregatesCalculation Calculate the aggregates that determine the
%equilibrium allocation.

Eta = Model.Parameters.Eta;
Gam = Model.Parameters.Gamma;

ZStar = ZStarCalculation( G_tminus1_wp , w_t_Zp , Z_t_wp , Pi_t , a_t , L , Model );

L_ = ( (Eta-1)./(Eta.*ZStar) ).^(Gam./(Gam+1));

end