function [ wMin_t , wMax_t ] = WSupportIteration( wMin_tminus1 , wMax_tminus1 , wZLow_t , wZHigh_t , Pi_t , a_t )
%WSupportIteration calculates path of support of detrended real wage distribution

wMin_t = min( wMin_tminus1./((1+a_t).*(1+Pi_t)) , wZLow_t );
wMax_t = max( wMax_tminus1./((1+a_t).*(1+Pi_t)) , wZHigh_t );

end

