function dpp = ppder( pp )
%DPP Takes derivative of the piecewise polynomial f
%  pp is a piecewise polynomial object.

dpp = pp;
N = pp.pieces;

[breaks,coefs,l,k,d] = unmkpp(pp);
% make the polynomial that describes the derivative
dpp = mkpp(breaks,repmat(k-1:-1:1,d*l,1).*coefs(:,1:k-1),d);

end

