function yy_ = ppvalcutoff( pp , xx , ylow , yhigh )
% PPVALCUTOFF piecewise polynomial evaluation with values outside of breaks

yy_ = ppval( pp , xx );

yy_ = ylow.*( xx < min(pp.breaks) ) + ...
      yy_.*(xx >= min(pp.breaks) ).*( xx <= max(pp.breaks) ) + ...
      yhigh.*( xx > max(pp.breaks) );

end

